<?php
/**
 * Google Media Sitemap
 * 
 * @package    Google Media Sitemap
 * @subpackage MediaSitemap Main Functions
/*  Copyright (c) 2017- Katsushi Kawamori (email : dodesyoswift312@gmail.com)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class MediaSitemap {

	/* ==================================================
	* @param	none
	* @return	feed
	* @since	1.00
	*/
	function add_custom_feed() {

		add_feed( 'googleimagesitemap', array($this, 'load_posts_create_feed') );

	}

	/* ==================================================
	* @param	none
	* @return	$feed
	* @since	1.00
	*/
	function load_posts_create_feed() {

		global $wpdb;
		$all_posts = $wpdb->get_results("
						SELECT	ID, post_content
						FROM	$wpdb->posts
						WHERE	 post_status = 'publish'
						");

		$feed = NULL;
		foreach ( $all_posts as $post ) {
			$feed .= $this->post_images($post->ID, $post->post_content);
		}

		$feed = '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?'.'>'."\n".
				'<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"'."\n".
				'		xmlns:image="http://www.google.com/schemas/sitemap-image/1.1">'."\n".
				$feed.
				'</urlset>';

		header('Content-Type: ' . feed_content_type('rss-http') . '; charset=' . get_option('blog_charset'), true);
		echo $feed;

	}

	/* ==================================================
	* @param	int		$pid
	* @param	string	$content
	* @return	string	$images
	* @since	1.00
	*/
	function post_images($pid, $content) {

		$images = NULL;

		// for short code
		$short_code = NULL;
		$pattern_short_code = '/\[.+?\]/im';
		if ( !empty($content) && preg_match($pattern_short_code, $content) ) {
			preg_match_all($pattern_short_code, $content, $retshortcode);
			foreach ( $retshortcode as $ret=>$shortcodes ) {
				foreach ( $shortcodes as $shortcode ) {
					$short_code = do_shortcode($shortcode);
					$content = str_replace( $shortcode, $short_code, $content );
				}
			}
		}

		if(preg_match_all('(https?://[-_.!~*\'()a-zA-Z0-9;/?:@&=+$,%#]+)', $content, $result) !== false){
			foreach( $result[0] as $value ) {
				$exts = explode('.', $value);
				$ext = end($exts);
				$ext2type = wp_ext2type($ext);
				if ( $ext2type === 'image' ) {
					$images .= "<image:image>\n";
					$images .= '<image:loc>'.$value.'</image:loc>'."\n";
					$images .= "</image:image>\n";
				}
			}
		}

		if ( !empty($images) ) {
			$head = "<url>\n";
			$head .= '<loc>'.get_permalink($pid).'</loc>'."\n";
			$foot = "</url>\n";
			$images = $head.$images.$foot;
		}

		return $images;

	}

	/* ==================================================
	* @param	array	$qv
	* @return	array	$qv
	* @since	1.00
	*/
	function myfeed_request( $qv ){

		if( isset( $qv['feed'] ) && !isset( $qv['post_type'] ) )
			$qv['post_type'] = array( 'post', 'page', '$post-type' );

		return $qv;

	}

	/* ==================================================
	* @param	none
	* @return	alternate link
	* @since	1.00
	*/
	function google_image_sitemap_alternate() {

		echo '<link rel="alternate" type="'.feed_content_type(). '" title="' .esc_attr(get_bloginfo('name')).' &raquo; Google Image Sitemap"'.' href="' . home_url("?feed=googleimagesitemap"). "\" />\n";

	}

}

?>