<?php
/**
 * Google Media Sitemap
 * 
 * @package    Google Media Sitemap
 * @subpackage MediaSitemapAdmin Management screen
    Copyright (c) 2017- Katsushi Kawamori (email : dodesyoswift312@gmail.com)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class MediaSitemapAdmin {

	/* ==================================================
	 * Add a "Settings" link to the plugins page
	 * @since	1.0
	 */
	function settings_link($links, $file) {
		static $this_plugin;
		if ( empty($this_plugin) ) {
			$this_plugin = MEDIASITEMAP_PLUGIN_BASE_FILE;
		}
		if ( $file == $this_plugin ) {
			$links[] = '<a href="'.admin_url('options-general.php?page=MediaSitemap').'">'.__( 'Settings').'</a>';
		}
		return $links;
	}

	/* ==================================================
	 * Settings page
	 * @since	1.0
	 */
	function plugin_menu() {
		add_options_page( 'MediaSitemap Options', 'Google Media Sitemap', 'manage_options', 'MediaSitemap', array($this, 'plugin_options') );
	}

	/* ==================================================
	 * Settings page
	 * @since	1.0
	 */
	function plugin_options() {

		if ( !current_user_can( 'manage_options' ) )  {
			wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
		}

		$plugin_datas = get_file_data( MEDIASITEMAP_PLUGIN_BASE_DIR.'/mediasitemap.php', array('version' => 'Version') );
		$plugin_version = __('Version:').' '.$plugin_datas['version'];

		?>
		<div class="wrap">
		<h2>Google Media Sitemap</h2>

		<span style="font-weight: bold;">
		<div>
		<?php echo $plugin_version; ?> |
		<a style="text-decoration: none;" href="https://wordpress.org/support/plugin/media-sitemap" target="_blank"><?php _e('Support Forums'); ?></a> |
		<a style="text-decoration: none;" href="https://wordpress.org/support/view/plugin-reviews/media-sitemap" target="_blank"><?php _e('Reviews', 'media-sitemap'); ?></a>
		</div>
		<div>
		<a style="text-decoration: none;" href="https://translate.wordpress.org/projects/wp-plugins/media-sitemap" target="_blank"><?php echo sprintf(__('Translations for %s'), 'Google Media Sitemap'); ?></a> | <a style="text-decoration: none;" href="https://www.facebook.com/katsushikawamori/" target="_blank"><span class="dashicons dashicons-facebook"></span></a> | <a style="text-decoration: none;" href="https://twitter.com/dodesyo312" target="_blank"><span class="dashicons dashicons-twitter"></span></a>
		</div>
		</span>
		<div style="width: 250px; height: 180px; margin: 5px; padding: 5px; border: #CCC 2px solid;">
		<h3><?php _e('Please make a donation if you like my work or would like to further the development of this plugin.', 'media-sitemap'); ?></h3>
		<div style="text-align: right; margin: 5px; padding: 5px;"><span style="padding: 3px; color: #ffffff; background-color: #008000">Plugin Author</span> <span style="font-weight: bold;">Katsushi Kawamori</span></div>
		<a style="margin: 5px; padding: 5px;" href='https://pledgie.com/campaigns/28307' target="_blank"><img alt='Click here to lend your support to: Various Plugins for WordPress and make a donation at pledgie.com !' src='https://pledgie.com/campaigns/28307.png?skin_name=chrome' border='0' ></a>
		</div>

		<hr>

		<?php
		$google_image_sitemaps_url = __('https://support.google.com/webmasters/answer/178636', 'media-sitemap');
		$image_sitemap_url = home_url("?feed=googleimagesitemap");
		?>
		<h3><a style="text-decoration: none;" href="<?php echo $google_image_sitemaps_url; ?>" target="_blank"><strong><?php _e('Image sitemaps', 'media-sitemap'); ?><span class="dashicons dashicons-editor-help"></span></strong></a> <span class="dashicons dashicons-arrow-right-alt"></span> <a style="text-decoration: none;" href="<?php echo $image_sitemap_url; ?>" target="_blank"><span style="font-weight: bold;"><?php echo $image_sitemap_url; ?></span><span class="dashicons dashicons-rss"></span></a></h3>

		<h3><?php _e('The following link is inserted in the header.', 'media-sitemap'); ?><span class="dashicons dashicons-hammer"></span></h3>
		<code>
		<?php echo esc_html('<link rel="alternate" type="'.feed_content_type(). '" title="' .esc_attr(get_bloginfo('name')).' &raquo; Google Image sitemaps"'.' href="' . home_url("?feed=googleimagesitemap").' />'); ?>
		</code>
		</div>
		<?php

	}

}

?>